   --  ,      
   -- - ,    
   --   tree
   ------------------------
   import TreeRB
   hBlack:: RBTree -> Integer
   hBlack tree | tree == (NIL ('B')) = 0
               | (snd (root tree) == 'B'  ||
                  snd (root tree) == 'R') && 
                 left tree == (NIL ('B')) && 
                 right tree == (NIL ('B')) 
                                     = 1    
               | (snd (root tree) == 'B'  ||
                  snd (root tree) == 'R') && 
                 left tree /= (NIL ('B')) &&
                 snd (root (left tree)) == 'B'
                                     = 1 + hBlack (left tree)
               | snd (root tree) == 'B'   && 
                 left tree /= (NIL ('B')) &&
                 snd (root (left tree)) == 'R'
                                     = 1 + hBlack (left tree)
               | True                = hBlack (left tree)
   ------------------------------------------------------
   --   
   --------------------------------
   test =   hBlack (NIL ('B')) == 0
         && hBlack (Node (1,'B') (NIL ('B')) (NIL ('B'))) == 1
         && hBlack (Node (1,'R') (NIL ('B')) (NIL ('B'))) == 1
         && hBlack (Node (5,'B')  
                         (Node (3,'B') (NIL ('B')) (NIL ('B')))
                         (Node (6,'B') (NIL ('B')) (NIL ('B')))) 
                                                               == 2
         && hBlack (Node (5,'R') 
                         (Node (3,'B') (NIL ('B')) (NIL ('B')))
                         (Node (6,'B') (NIL ('B')) (NIL ('B'))))  
                                                               == 2
         && hBlack (Node (5,'B') 
                         (Node (3,'B') (NIL ('B')) (NIL ('B')))
                         (Node (10,'R') 
                               (Node (8,'B') 
                                     (Node (7,'R') (NIL ('B'))
                                                   (NIL ('B')))
                                     (NIL ('B'))) 
                               (Node (11,'B') (NIL ('B')) 
                                              (NIL ('B'))))) == 2
         && hBlack (Node (5,'R') 
                         (Node (3,'B') (NIL ('B')) (NIL ('B'))) 
                         (Node (8,'B') 
                               (Node (7,'R') (NIL ('B')) 
                                             (NIL ('B'))) 
                               (NIL ('B')))) == 2
         && hBlack (Node (10,'B') 
                         (Node (3,'B') 
                               (Node (2,'B') (NIL ('B')) 
                                             (NIL ('B')))
                               (Node (8,'R') 
                                     (Node (5,'B') 
                                           (Node (1,'R') 
                                                 (NIL ('B')) 
                                                 (NIL ('B')))
                                           (NIL ('B')))
                                     (Node (9,'B') 
                                           (NIL ('B')) 
                                           (NIL ('B')))))
                               (Node (13,'B') 
                                     (Node (12,'B') 
                                           (NIL ('B')) 
                                           (NIL ('B')))
                                     (Node (18,'R') 
                                           (Node (15,'B') 
                                                 (Node (14,'R')
                                                       (NIL ('B'))
                                                       (NIL ('B')))
                                                 (NIL ('B'))) 
                                           (Node (19,'B') 
                                                 (NIL ('B'))
                                                 (NIL ('B')))))) 
                                                               == 3